// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/complete_platform.hpp"



complete_platform::complete_platform() :
    sensor_low_old(false),
    sensor_high_old(false),
    rst_old(false),
    clk_old(false),
    hif_a2t_data(
    false,
    false,
    false,
    false,
    false,
    false,
    uint16_t(0U)),
    apb_master_pclk(false),
    apb_master_presetn(false),
    apb_master_paddr(0UL),
    apb_master_psel1(false),
    apb_master_psel2(false),
    apb_master_psel3(false),
    apb_master_psel4(false),
    apb_master_psel5(false),
    apb_master_psel6(false),
    apb_master_psel7(false),
    apb_master_psel8(false),
    apb_master_penable(false),
    apb_master_pwrite(false),
    apb_master_pwdata(0UL),
    apb_master_pready(false),
    apb_master_prdata(0UL),
    apb_1_pclk(false),
    apb_1_presetn(false),
    apb_1_paddr(0UL),
    apb_1_psel(false),
    apb_1_penable(false),
    apb_1_pwrite(false),
    apb_1_pwdata(0UL),
    apb_1_pready(false),
    apb_1_prdata(0UL),
    apb_2_pclk(false),
    apb_2_presetn(false),
    apb_2_paddr(0UL),
    apb_2_psel(false),
    apb_2_penable(false),
    apb_2_pwrite(false),
    apb_2_pwdata(0UL),
    apb_2_pready(false),
    apb_2_prdata(0UL),
    apb_3_pclk(false),
    apb_3_presetn(false),
    apb_3_paddr(0UL),
    apb_3_psel(false),
    apb_3_penable(false),
    apb_3_pwrite(false),
    apb_3_pwdata(0UL),
    apb_3_pready(false),
    apb_3_prdata(0UL),
    apb_4_pclk(false),
    apb_4_presetn(false),
    apb_4_paddr(0UL),
    apb_4_psel(false),
    apb_4_penable(false),
    apb_4_pwrite(false),
    apb_4_pwdata(0UL),
    apb_4_pready(false),
    apb_4_prdata(0UL),
    apb_5_pclk(false),
    apb_5_presetn(false),
    apb_5_paddr(0UL),
    apb_5_psel(false),
    apb_5_penable(false),
    apb_5_pwrite(false),
    apb_5_pwdata(0UL),
    apb_5_pready(false),
    apb_5_prdata(0UL),
    apb_6_pclk(false),
    apb_6_presetn(false),
    apb_6_paddr(0UL),
    apb_6_psel(false),
    apb_6_penable(false),
    apb_6_pwrite(false),
    apb_6_pwdata(0UL),
    apb_6_pready(false),
    apb_6_prdata(0UL),
    apb_7_pclk(false),
    apb_7_presetn(false),
    apb_7_paddr(0UL),
    apb_7_psel(false),
    apb_7_penable(false),
    apb_7_pwrite(false),
    apb_7_pwdata(0UL),
    apb_7_pready(false),
    apb_7_prdata(0UL),
    apb_8_pclk(false),
    apb_8_presetn(false),
    apb_8_paddr(0UL),
    apb_8_psel(false),
    apb_8_penable(false),
    apb_8_pwrite(false),
    apb_8_pwdata(0UL),
    apb_8_pready(false),
    apb_8_prdata(0UL),
    addr(uint16_t(0U)),
    datai(uint8_t(0U)),
    datao(uint8_t(0U)),
    oeb(false),
    irq_n(false),
    nmi_n(false),
    res_n(false),
    rdy(false),
    sob_n(false),
    sync(false),
    vpab(false),
    we_n(false),
    m6502_0(),
    memory_0(),
    amba_apb_bus_0(),
    multiplier_0(),
    accelerometer_0(),
    network_interface_0(),
    lfsr_0(),
    sensor_0(),
    actuator_0(),
    watchdog_0(),
    apb_master_pclk_new(false),
    apb_master_presetn_new(false),
    apb_master_paddr_new(0UL),
    apb_master_psel1_new(false),
    apb_master_psel2_new(false),
    apb_master_psel3_new(false),
    apb_master_psel4_new(false),
    apb_master_psel5_new(false),
    apb_master_psel6_new(false),
    apb_master_psel7_new(false),
    apb_master_psel8_new(false),
    apb_master_penable_new(false),
    apb_master_pwrite_new(false),
    apb_master_pwdata_new(0UL),
    apb_master_pready_new(false),
    apb_master_prdata_new(0UL),
    apb_1_pclk_new(false),
    apb_1_presetn_new(false),
    apb_1_paddr_new(0UL),
    apb_1_psel_new(false),
    apb_1_penable_new(false),
    apb_1_pwrite_new(false),
    apb_1_pwdata_new(0UL),
    apb_1_pready_new(false),
    apb_1_prdata_new(0UL),
    apb_2_pclk_new(false),
    apb_2_presetn_new(false),
    apb_2_paddr_new(0UL),
    apb_2_psel_new(false),
    apb_2_penable_new(false),
    apb_2_pwrite_new(false),
    apb_2_pwdata_new(0UL),
    apb_2_pready_new(false),
    apb_2_prdata_new(0UL),
    apb_3_pclk_new(false),
    apb_3_presetn_new(false),
    apb_3_paddr_new(0UL),
    apb_3_psel_new(false),
    apb_3_penable_new(false),
    apb_3_pwrite_new(false),
    apb_3_pwdata_new(0UL),
    apb_3_pready_new(false),
    apb_3_prdata_new(0UL),
    apb_4_pclk_new(false),
    apb_4_presetn_new(false),
    apb_4_paddr_new(0UL),
    apb_4_psel_new(false),
    apb_4_penable_new(false),
    apb_4_pwrite_new(false),
    apb_4_pwdata_new(0UL),
    apb_4_pready_new(false),
    apb_4_prdata_new(0UL),
    apb_5_pclk_new(false),
    apb_5_presetn_new(false),
    apb_5_paddr_new(0UL),
    apb_5_psel_new(false),
    apb_5_penable_new(false),
    apb_5_pwrite_new(false),
    apb_5_pwdata_new(0UL),
    apb_5_pready_new(false),
    apb_5_prdata_new(0UL),
    apb_6_pclk_new(false),
    apb_6_presetn_new(false),
    apb_6_paddr_new(0UL),
    apb_6_psel_new(false),
    apb_6_penable_new(false),
    apb_6_pwrite_new(false),
    apb_6_pwdata_new(0UL),
    apb_6_pready_new(false),
    apb_6_prdata_new(0UL),
    apb_7_pclk_new(false),
    apb_7_presetn_new(false),
    apb_7_paddr_new(0UL),
    apb_7_psel_new(false),
    apb_7_penable_new(false),
    apb_7_pwrite_new(false),
    apb_7_pwdata_new(0UL),
    apb_7_pready_new(false),
    apb_7_prdata_new(0UL),
    apb_8_pclk_new(false),
    apb_8_presetn_new(false),
    apb_8_paddr_new(0UL),
    apb_8_psel_new(false),
    apb_8_penable_new(false),
    apb_8_pwrite_new(false),
    apb_8_pwdata_new(0UL),
    apb_8_pready_new(false),
    apb_8_prdata_new(0UL),
    addr_new(uint16_t(0U)),
    datai_new(uint8_t(0U)),
    datao_new(uint8_t(0U)),
    oeb_new(false),
    irq_n_new(false),
    nmi_n_new(false),
    res_n_new(false),
    rdy_new(false),
    sob_n_new(false),
    sync_new(false),
    vpab_new(false),
    we_n_new(false),
    process_in_queue(false),
    _bindings_completed(perform_bindings())
{
}


complete_platform::~complete_platform()
{}



bool complete_platform::perform_bindings()
{
    m6502_0.hif_a2t_data.clk = &hif_a2t_data.clk;
    m6502_0.hif_a2t_data.addr = &addr_new;
    m6502_0.hif_a2t_data.datai = &datai;
    m6502_0.hif_a2t_data.datao = &datao_new;
    m6502_0.hif_a2t_data.oeb = &oeb_new;
    m6502_0.hif_a2t_data.irq_n = &irq_n;
    m6502_0.hif_a2t_data.nmi_n = &nmi_n;
    m6502_0.hif_a2t_data.res_n = &res_n;
    m6502_0.hif_a2t_data.rdy = &rdy;
    m6502_0.hif_a2t_data.sob_n = &sob_n;
    m6502_0.hif_a2t_data.sync = &sync_new;
    m6502_0.hif_a2t_data.vpab = &vpab_new;
    m6502_0.hif_a2t_data.we_n = &we_n_new;
    memory_0.hif_a2t_data.clk = &hif_a2t_data.clk;
    memory_0.hif_a2t_data.rst = &hif_a2t_data.rst;
    memory_0.hif_a2t_data.addr = &addr;
    memory_0.hif_a2t_data.datai = &datai_new;
    memory_0.hif_a2t_data.datao = &datao;
    memory_0.hif_a2t_data.irq_n = &irq_n_new;
    memory_0.hif_a2t_data.nmi_n = &nmi_n_new;
    memory_0.hif_a2t_data.sob_n = &sob_n_new;
    memory_0.hif_a2t_data.res_n = &res_n_new;
    memory_0.hif_a2t_data.rdy = &rdy_new;
    memory_0.hif_a2t_data.vpab = &vpab;
    memory_0.hif_a2t_data.sync = &sync;
    memory_0.hif_a2t_data.we_n = &we_n;
    memory_0.hif_a2t_data.oeb = &oeb;
    memory_0.hif_a2t_data.psel1 = &apb_master_psel1_new;
    memory_0.hif_a2t_data.psel2 = &apb_master_psel2_new;
    memory_0.hif_a2t_data.psel3 = &apb_master_psel3_new;
    memory_0.hif_a2t_data.psel4 = &apb_master_psel4_new;
    memory_0.hif_a2t_data.psel5 = &apb_master_psel5_new;
    memory_0.hif_a2t_data.psel6 = &apb_master_psel6_new;
    memory_0.hif_a2t_data.psel7 = &apb_master_psel7_new;
    memory_0.hif_a2t_data.psel8 = &apb_master_psel8_new;
    memory_0.hif_a2t_data.penable = &apb_master_penable_new;
    memory_0.hif_a2t_data.presetn = &apb_master_presetn_new;
    memory_0.hif_a2t_data.paddr = &apb_master_paddr_new;
    memory_0.hif_a2t_data.pwrite = &apb_master_pwrite_new;
    memory_0.hif_a2t_data.pwdata = &apb_master_pwdata_new;
    memory_0.hif_a2t_data.pready = &apb_master_pready;
    memory_0.hif_a2t_data.prdata = &apb_master_prdata;
    amba_apb_bus_0.hif_a2t_data.clk = &hif_a2t_data.clk;
    amba_apb_bus_0.hif_a2t_data.apb_master_pclk = &apb_master_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_master_presetn = &apb_master_presetn;
    amba_apb_bus_0.hif_a2t_data.apb_master_paddr = &apb_master_paddr;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel1 = &apb_master_psel1;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel2 = &apb_master_psel2;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel3 = &apb_master_psel3;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel4 = &apb_master_psel4;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel5 = &apb_master_psel5;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel6 = &apb_master_psel6;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel7 = &apb_master_psel7;
    amba_apb_bus_0.hif_a2t_data.apb_master_psel8 = &apb_master_psel8;
    amba_apb_bus_0.hif_a2t_data.apb_master_penable = &apb_master_penable;
    amba_apb_bus_0.hif_a2t_data.apb_master_pwrite = &apb_master_pwrite;
    amba_apb_bus_0.hif_a2t_data.apb_master_pwdata = &apb_master_pwdata;
    amba_apb_bus_0.hif_a2t_data.apb_master_pready = &apb_master_pready_new;
    amba_apb_bus_0.hif_a2t_data.apb_master_prdata = &apb_master_prdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_pclk = &apb_1_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_presetn = &apb_1_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_paddr = &apb_1_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_psel = &apb_1_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_penable = &apb_1_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_pwrite = &apb_1_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_pwdata = &apb_1_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_1_pready = &apb_1_pready;
    amba_apb_bus_0.hif_a2t_data.apb_1_prdata = &apb_1_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_2_pclk = &apb_2_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_presetn = &apb_2_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_paddr = &apb_2_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_psel = &apb_2_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_penable = &apb_2_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_pwrite = &apb_2_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_pwdata = &apb_2_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_2_pready = &apb_2_pready;
    amba_apb_bus_0.hif_a2t_data.apb_2_prdata = &apb_2_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_3_pclk = &apb_3_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_presetn = &apb_3_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_paddr = &apb_3_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_psel = &apb_3_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_penable = &apb_3_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_pwrite = &apb_3_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_pwdata = &apb_3_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_3_pready = &apb_3_pready;
    amba_apb_bus_0.hif_a2t_data.apb_3_prdata = &apb_3_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_4_pclk = &apb_4_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_presetn = &apb_4_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_paddr = &apb_4_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_psel = &apb_4_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_penable = &apb_4_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_pwrite = &apb_4_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_pwdata = &apb_4_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_4_pready = &apb_4_pready;
    amba_apb_bus_0.hif_a2t_data.apb_4_prdata = &apb_4_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_5_pclk = &apb_5_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_presetn = &apb_5_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_paddr = &apb_5_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_psel = &apb_5_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_penable = &apb_5_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_pwrite = &apb_5_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_pwdata = &apb_5_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_5_pready = &apb_5_pready;
    amba_apb_bus_0.hif_a2t_data.apb_5_prdata = &apb_5_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_6_pclk = &apb_6_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_presetn = &apb_6_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_paddr = &apb_6_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_psel = &apb_6_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_penable = &apb_6_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_pwrite = &apb_6_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_pwdata = &apb_6_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_6_pready = &apb_6_pready;
    amba_apb_bus_0.hif_a2t_data.apb_6_prdata = &apb_6_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_7_pclk = &apb_7_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_presetn = &apb_7_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_paddr = &apb_7_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_psel = &apb_7_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_penable = &apb_7_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_pwrite = &apb_7_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_pwdata = &apb_7_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_7_pready = &apb_7_pready;
    amba_apb_bus_0.hif_a2t_data.apb_7_prdata = &apb_7_prdata;
    amba_apb_bus_0.hif_a2t_data.apb_8_pclk = &apb_8_pclk_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_presetn = &apb_8_presetn_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_paddr = &apb_8_paddr_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_psel = &apb_8_psel_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_penable = &apb_8_penable_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_pwrite = &apb_8_pwrite_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_pwdata = &apb_8_pwdata_new;
    amba_apb_bus_0.hif_a2t_data.apb_8_pready = &apb_8_pready;
    amba_apb_bus_0.hif_a2t_data.apb_8_prdata = &apb_8_prdata;
    multiplier_0.hif_a2t_data.pclk = &apb_1_pclk;
    multiplier_0.hif_a2t_data.presetn = &apb_1_presetn;
    multiplier_0.hif_a2t_data.paddr = &apb_1_paddr;
    multiplier_0.hif_a2t_data.psel = &apb_1_psel;
    multiplier_0.hif_a2t_data.penable = &apb_1_penable;
    multiplier_0.hif_a2t_data.pwrite = &apb_1_pwrite;
    multiplier_0.hif_a2t_data.pwdata = &apb_1_pwdata;
    multiplier_0.hif_a2t_data.pready = &apb_1_pready_new;
    multiplier_0.hif_a2t_data.prdata = &apb_1_prdata_new;
    accelerometer_0.hif_a2t_data.pclk = &apb_2_pclk;
    accelerometer_0.hif_a2t_data.presetn = &apb_2_presetn;
    accelerometer_0.hif_a2t_data.paddr = &apb_2_paddr;
    accelerometer_0.hif_a2t_data.psel = &apb_2_psel;
    accelerometer_0.hif_a2t_data.penable = &apb_2_penable;
    accelerometer_0.hif_a2t_data.pwrite = &apb_2_pwrite;
    accelerometer_0.hif_a2t_data.pwdata = &apb_2_pwdata;
    accelerometer_0.hif_a2t_data.pready = &apb_2_pready_new;
    accelerometer_0.hif_a2t_data.prdata = &apb_2_prdata_new;
    accelerometer_0.hif_a2t_data.analog_clock = &apb_2_pclk;
    network_interface_0.hif_a2t_data.pclk = &apb_3_pclk;
    network_interface_0.hif_a2t_data.presetn = &apb_3_presetn;
    network_interface_0.hif_a2t_data.paddr = &apb_3_paddr;
    network_interface_0.hif_a2t_data.psel = &apb_3_psel;
    network_interface_0.hif_a2t_data.penable = &apb_3_penable;
    network_interface_0.hif_a2t_data.pwrite = &apb_3_pwrite;
    network_interface_0.hif_a2t_data.pwdata = &apb_3_pwdata;
    network_interface_0.hif_a2t_data.pready = &apb_3_pready_new;
    network_interface_0.hif_a2t_data.prdata = &apb_3_prdata_new;
    lfsr_0.hif_a2t_data.pclk = &apb_4_pclk;
    lfsr_0.hif_a2t_data.presetn = &apb_4_presetn;
    lfsr_0.hif_a2t_data.paddr = &apb_4_paddr;
    lfsr_0.hif_a2t_data.psel = &apb_4_psel;
    lfsr_0.hif_a2t_data.penable = &apb_4_penable;
    lfsr_0.hif_a2t_data.pwrite = &apb_4_pwrite;
    lfsr_0.hif_a2t_data.pwdata = &apb_4_pwdata;
    lfsr_0.hif_a2t_data.pready = &apb_4_pready_new;
    lfsr_0.hif_a2t_data.prdata = &apb_4_prdata_new;
    sensor_0.hif_a2t_data.pclk = &apb_5_pclk;
    sensor_0.hif_a2t_data.presetn = &apb_5_presetn;
    sensor_0.hif_a2t_data.paddr = &apb_5_paddr;
    sensor_0.hif_a2t_data.psel = &apb_5_psel;
    sensor_0.hif_a2t_data.penable = &apb_5_penable;
    sensor_0.hif_a2t_data.pwrite = &apb_5_pwrite;
    sensor_0.hif_a2t_data.pwdata = &apb_5_pwdata;
    sensor_0.hif_a2t_data.pready = &apb_5_pready_new;
    sensor_0.hif_a2t_data.prdata = &apb_5_prdata_new;
    sensor_0.hif_a2t_data.sensor_high = &hif_a2t_data.sensor_high;
    sensor_0.hif_a2t_data.sensor_low = &hif_a2t_data.sensor_low;
    actuator_0.hif_a2t_data.pclk = &apb_6_pclk;
    actuator_0.hif_a2t_data.presetn = &apb_6_presetn;
    actuator_0.hif_a2t_data.paddr = &apb_6_paddr;
    actuator_0.hif_a2t_data.psel = &apb_6_psel;
    actuator_0.hif_a2t_data.penable = &apb_6_penable;
    actuator_0.hif_a2t_data.pwrite = &apb_6_pwrite;
    actuator_0.hif_a2t_data.pwdata = &apb_6_pwdata;
    actuator_0.hif_a2t_data.pready = &apb_6_pready_new;
    actuator_0.hif_a2t_data.prdata = &apb_6_prdata_new;
    actuator_0.hif_a2t_data.actuator_open = &hif_a2t_data.actuator_open;
    actuator_0.hif_a2t_data.actuator_close = &hif_a2t_data.actuator_close;
    actuator_0.hif_a2t_data.actuator_threshold = &hif_a2t_data.actuator_threshold;
    watchdog_0.hif_a2t_data.pclk = &apb_7_pclk;
    watchdog_0.hif_a2t_data.presetn = &apb_7_presetn;
    watchdog_0.hif_a2t_data.paddr = &apb_7_paddr;
    watchdog_0.hif_a2t_data.psel = &apb_7_psel;
    watchdog_0.hif_a2t_data.penable = &apb_7_penable;
    watchdog_0.hif_a2t_data.pwrite = &apb_7_pwrite;
    watchdog_0.hif_a2t_data.pwdata = &apb_7_pwdata;
    watchdog_0.hif_a2t_data.pready = &apb_7_pready_new;
    watchdog_0.hif_a2t_data.prdata = &apb_7_prdata_new;
    multiplier_0.perform_bindings();
    network_interface_0.perform_bindings();
    return true;
}


void complete_platform::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    clk_old = hif_a2t_data.clk;
    rst_old = hif_a2t_data.rst;
    sensor_high_old = hif_a2t_data.sensor_high;
    sensor_low_old = hif_a2t_data.sensor_low;
    if (synch_phase)
    {
        m6502_0.update_input_queue( true );
        memory_0.update_input_queue( true );
        amba_apb_bus_0.update_input_queue( true );
        multiplier_0.update_input_queue( true );
        accelerometer_0.update_input_queue( true );
        network_interface_0.update_input_queue( true );
        lfsr_0.update_input_queue( true );
        sensor_0.update_input_queue( true );
        actuator_0.update_input_queue( true );
        watchdog_0.update_input_queue( true );
        process_in_queue = process_in_queue || (m6502_0.process_in_queue || (memory_0.process_in_queue
             || (amba_apb_bus_0.process_in_queue || (multiplier_0.process_in_queue
             || (accelerometer_0.process_in_queue || (network_interface_0.process_in_queue
             || (lfsr_0.process_in_queue || (sensor_0.process_in_queue || (actuator_0.process_in_queue
             || watchdog_0.process_in_queue)))))))));
    }
}


void complete_platform::update_event_queue()
{
    process_in_queue = false;
    addr = addr_new;
    apb_1_paddr = apb_1_paddr_new;
    apb_1_pclk = apb_1_pclk_new;
    apb_1_penable = apb_1_penable_new;
    apb_1_prdata = apb_1_prdata_new;
    apb_1_pready = apb_1_pready_new;
    apb_1_presetn = apb_1_presetn_new;
    apb_1_psel = apb_1_psel_new;
    apb_1_pwdata = apb_1_pwdata_new;
    apb_1_pwrite = apb_1_pwrite_new;
    apb_2_paddr = apb_2_paddr_new;
    apb_2_pclk = apb_2_pclk_new;
    apb_2_penable = apb_2_penable_new;
    apb_2_prdata = apb_2_prdata_new;
    apb_2_pready = apb_2_pready_new;
    apb_2_presetn = apb_2_presetn_new;
    apb_2_psel = apb_2_psel_new;
    apb_2_pwdata = apb_2_pwdata_new;
    apb_2_pwrite = apb_2_pwrite_new;
    apb_3_paddr = apb_3_paddr_new;
    apb_3_pclk = apb_3_pclk_new;
    apb_3_penable = apb_3_penable_new;
    apb_3_prdata = apb_3_prdata_new;
    apb_3_pready = apb_3_pready_new;
    apb_3_presetn = apb_3_presetn_new;
    apb_3_psel = apb_3_psel_new;
    apb_3_pwdata = apb_3_pwdata_new;
    apb_3_pwrite = apb_3_pwrite_new;
    apb_4_paddr = apb_4_paddr_new;
    apb_4_pclk = apb_4_pclk_new;
    apb_4_penable = apb_4_penable_new;
    apb_4_prdata = apb_4_prdata_new;
    apb_4_pready = apb_4_pready_new;
    apb_4_presetn = apb_4_presetn_new;
    apb_4_psel = apb_4_psel_new;
    apb_4_pwdata = apb_4_pwdata_new;
    apb_4_pwrite = apb_4_pwrite_new;
    apb_5_paddr = apb_5_paddr_new;
    apb_5_pclk = apb_5_pclk_new;
    apb_5_penable = apb_5_penable_new;
    apb_5_prdata = apb_5_prdata_new;
    apb_5_pready = apb_5_pready_new;
    apb_5_presetn = apb_5_presetn_new;
    apb_5_psel = apb_5_psel_new;
    apb_5_pwdata = apb_5_pwdata_new;
    apb_5_pwrite = apb_5_pwrite_new;
    apb_6_paddr = apb_6_paddr_new;
    apb_6_pclk = apb_6_pclk_new;
    apb_6_penable = apb_6_penable_new;
    apb_6_prdata = apb_6_prdata_new;
    apb_6_pready = apb_6_pready_new;
    apb_6_presetn = apb_6_presetn_new;
    apb_6_psel = apb_6_psel_new;
    apb_6_pwdata = apb_6_pwdata_new;
    apb_6_pwrite = apb_6_pwrite_new;
    apb_7_paddr = apb_7_paddr_new;
    apb_7_pclk = apb_7_pclk_new;
    apb_7_penable = apb_7_penable_new;
    apb_7_prdata = apb_7_prdata_new;
    apb_7_pready = apb_7_pready_new;
    apb_7_presetn = apb_7_presetn_new;
    apb_7_psel = apb_7_psel_new;
    apb_7_pwdata = apb_7_pwdata_new;
    apb_7_pwrite = apb_7_pwrite_new;
    apb_8_paddr = apb_8_paddr_new;
    apb_8_pclk = apb_8_pclk_new;
    apb_8_penable = apb_8_penable_new;
    apb_8_prdata = apb_8_prdata_new;
    apb_8_pready = apb_8_pready_new;
    apb_8_presetn = apb_8_presetn_new;
    apb_8_psel = apb_8_psel_new;
    apb_8_pwdata = apb_8_pwdata_new;
    apb_8_pwrite = apb_8_pwrite_new;
    apb_master_paddr = apb_master_paddr_new;
    apb_master_pclk = apb_master_pclk_new;
    apb_master_penable = apb_master_penable_new;
    apb_master_prdata = apb_master_prdata_new;
    apb_master_pready = apb_master_pready_new;
    apb_master_presetn = apb_master_presetn_new;
    apb_master_psel1 = apb_master_psel1_new;
    apb_master_psel2 = apb_master_psel2_new;
    apb_master_psel3 = apb_master_psel3_new;
    apb_master_psel4 = apb_master_psel4_new;
    apb_master_psel5 = apb_master_psel5_new;
    apb_master_psel6 = apb_master_psel6_new;
    apb_master_psel7 = apb_master_psel7_new;
    apb_master_psel8 = apb_master_psel8_new;
    apb_master_pwdata = apb_master_pwdata_new;
    apb_master_pwrite = apb_master_pwrite_new;
    datai = datai_new;
    datao = datao_new;
    irq_n = irq_n_new;
    nmi_n = nmi_n_new;
    oeb = oeb_new;
    rdy = rdy_new;
    res_n = res_n_new;
    sob_n = sob_n_new;
    sync = sync_new;
    vpab = vpab_new;
    we_n = we_n_new;
    m6502_0.update_event_queue();
    memory_0.update_event_queue();
    amba_apb_bus_0.update_event_queue();
    multiplier_0.update_event_queue();
    accelerometer_0.update_event_queue();
    network_interface_0.update_event_queue();
    lfsr_0.update_event_queue();
    sensor_0.update_event_queue();
    actuator_0.update_event_queue();
    watchdog_0.update_event_queue();
    process_in_queue = process_in_queue || (m6502_0.process_in_queue || (memory_0.process_in_queue
         || (amba_apb_bus_0.process_in_queue || (multiplier_0.process_in_queue ||
         (accelerometer_0.process_in_queue || (network_interface_0.process_in_queue
         || (lfsr_0.process_in_queue || (sensor_0.process_in_queue || (actuator_0.process_in_queue
         || watchdog_0.process_in_queue)))))))));
}


void complete_platform::flag_elaboration()
{
    if (m6502_0.process_in_queue)
    {
        m6502_0.flag_elaboration();
    }
    if (memory_0.process_in_queue)
    {
        memory_0.flag_elaboration();
    }
    if (amba_apb_bus_0.process_in_queue)
    {
        amba_apb_bus_0.flag_elaboration();
    }
    if (multiplier_0.process_in_queue)
    {
        multiplier_0.flag_elaboration();
    }
    if (accelerometer_0.process_in_queue)
    {
        accelerometer_0.flag_elaboration();
    }
    if (network_interface_0.process_in_queue)
    {
        network_interface_0.flag_elaboration();
    }
    if (lfsr_0.process_in_queue)
    {
        lfsr_0.flag_elaboration();
    }
    if (sensor_0.process_in_queue)
    {
        sensor_0.flag_elaboration();
    }
    if (actuator_0.process_in_queue)
    {
        actuator_0.flag_elaboration();
    }
    if (watchdog_0.process_in_queue)
    {
        watchdog_0.flag_elaboration();
    }
}


void complete_platform::synch_elaboration()
{
    update_input_queue( true );
    flag_elaboration();
    update_event_queue();
}


void complete_platform::simulate( complete_platform_iostruct * io_exchange, int32_t
     & cycles_number )
{
    hif_a2t_data.clk = io_exchange->clk;
    hif_a2t_data.rst = io_exchange->rst;
    hif_a2t_data.sensor_high = io_exchange->sensor_high;
    hif_a2t_data.sensor_low = io_exchange->sensor_low;
    cycles_number = cycles_number + 1L;
    synch_elaboration();
    while (process_in_queue)
    {
        flag_elaboration();
        update_event_queue();
    }
    io_exchange->actuator_open = hif_a2t_data.actuator_open;
    io_exchange->actuator_close = hif_a2t_data.actuator_close;
    io_exchange->actuator_threshold = hif_a2t_data.actuator_threshold;
}


void complete_platform::start_of_simulation()
{
    update_event_queue();
}


void complete_platform::initialize()
{
    start_of_simulation();
    m6502_0.initialize();
    memory_0.initialize();
    amba_apb_bus_0.initialize();
    multiplier_0.initialize();
    accelerometer_0.initialize();
    network_interface_0.initialize();
    lfsr_0.initialize();
    sensor_0.initialize();
    actuator_0.initialize();
    watchdog_0.initialize();
}


void complete_platform::finalize()
{
}




